import {
  AccessibleObject,
  Executable,
} from '@overflow/commons/core/reflect';

export class Parameter extends AccessibleObject {
  private _executable: Executable;
  private _type: any;
  private _index: number;

  public constructor(executable: Executable, parameterType: any, index: number) {
    super();
    this._executable = executable;
    this._type = parameterType;
    this._index = index;
  }

  public getDeclaringExecutable(): Executable {
    return this._executable;
  }

  public getType(): any {
    return this._type;
  }

  public getIndex(): number {
    return this._index;
  }
}
