import {
  PropertyKeyType,
} from '@overflow/commons/core/type';

import {
  Class,
  Executable,
 } from '@overflow/commons/core/reflect';

export class Constructor extends Executable {

  public constructor(declaringClazz: Class, parameterTypes: any[]) {
    super(declaringClazz, parameterTypes);
  }

  public getName(): PropertyKeyType {
    return this.getDeclaringClass().getName();
  }
}
